package com.jeeplus.assess.invoice.mapper;

import com.baomidou.mybatisplus.annotation.InterceptorIgnore;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jeeplus.assess.invoice.domain.FinanceInvoice;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.jeeplus.assess.invoice.service.dto.FinanceInvoiceDTO;
import com.jeeplus.assess.program.configuration.fileDict.domain.ProgramFileDict;
import com.jeeplus.assess.program.configuration.fileDict.service.dto.ProgramFileDictDTO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @Entity com.jeeplus.test.finance.invoice.domain.FinanceInvoice
 */
@Mapper
//@InterceptorIgnore(tenantLine = "true")
public interface FinanceInvoiceMapper extends BaseMapper<FinanceInvoice> {

    IPage<FinanceInvoiceDTO> findList(Page<FinanceInvoiceDTO> page, @Param(Constants.WRAPPER) QueryWrapper<FinanceInvoice> queryWrapper);
    //查询红字发票数据
    IPage<FinanceInvoiceDTO> findRedList(Page<FinanceInvoiceDTO> page, @Param(Constants.WRAPPER) QueryWrapper<FinanceInvoice> queryWrapper);
    //@InterceptorIgnore(tenantLine = "true")
    FinanceInvoiceDTO queryById(@Param("id") String id);

    /**
     * 根据发票id清空发票的收款日期
     * @param id
     */
    void setReceivablesDateNull(@Param("id") String id);

    List<FinanceInvoiceDTO> getExceedFinance();

    String getInvoiceNumberStr(String id);
}




