package com.jeeplus.assess.reimbursement.reimbursementInfo.domain;

import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.jeeplus.core.domain.BaseEntity;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
@TableName(value = "reimbursement_info")
public class ReimbursementInfo extends BaseEntity {

    /**
     * 经办人id
     */
    private String userId;

    /**
     * 经办人名称
     */
    private String userName;

    /**
     * 报销编号
     */
    private String no;

    /**
     * 所属部门
     */
    private String department;

    /**
     * 报销日期
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    private Date reimDate;

    /**
     * 备注
     */
    private String remarks;

    /**
     * 状态
     */
    private String type;

    /**
     * 流程id
     */
    private String procInsId;

    /**
     *
     */
    private String processDefinitionId;

    /**
     * 报销类型
     */
    private String sourceType;

    private String purchaseId;

    private String reimbursementType; // 报销类型（0：普通报销；1：电子发票报销）
    //送审日期
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    private Date approvalTime;

    /**
     * 付款时间
     */
    private Date paymentTime;
    /**
     * 付款状态  0:未付款  1:已付款
     */
    private String paymentStatus;
}
