package com.jeeplus.centrecareful.approvalInfo.domain;

import com.baomidou.mybatisplus.annotation.TableName;
import com.jeeplus.core.domain.BaseEntity;
import lombok.Data;

/**
 * 中审-报销专用发票信息表
 * @author: 王强
 * @create: 2022-11-24 15:49
 **/
@Data
@TableName(value = "zs_reimbursement_amount_info")
public class ZsReimbursementAmountInfo extends BaseEntity {

    /**
     * 关联id
     */
    private String infoId;

    /**
     * 发票代码
     */
    private String code;

    /**
     * 发票编号
     */
    private String number;

    /**
     * 金额
     */
    private String amount;

    /**
     * 税额
     */
    private String taxAmount;

    /**
     * 价税合计
     */
    private String count;

    /**
     * 报销类型（0：普通报销；1：电子发票报销）
     */
    private String reimbursementType;

    /**
     * 发票类型（01：增值税发票；02：普通发票）
     */
    private String invoiceType;

    /**
     * 发票项目名
     */
    private String invoiceProjectName;

    /**
     * 开票时间
     */
    private String invoiceDate;

    /**
     * 开票单位
     */
    private String invoiceUnit;

    /**
     * 购买方名称
     */
    private String buyerName;

    /**
     * 备注
     */
    private String remarks;


    /**
     * 对应附件url
     */
    private String fileUrl;
    /**
     * 文件类型-后缀名
     */
    private String fileType;
    /**
     * 文件名
     */
    private String attachmentName;
    /**
     * 文件所属业务模块
     */
    private String attachmentFlag;
    /**
     * 文件大小
     */
    private String fileSize;

}
