package com.jeeplus.consultancy.approvalInfo.service.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.jeeplus.core.domain.BaseEntity;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
public class ConsultancyQueryListDto extends BaseEntity {

    /**
     * 报销项目
     */
    private String project;

    /**
     * 报销时间
     */
    private String[] dates;

    /**
     * 经办人
     */
    private String handled;

    /**
     * 报销人
     */
    private String reimBy;

    /**
     * 报销状态
     */
    private String type;

    /**
     * 报销部门
     */
    private String department;

    /**
     * 报销类别
     */
    private String remiType;

    /**
     * 报销金额
     */
    private String[] amounts;

    /**
     * 报告号
     */
    private String reportNumber;

    /**
     * 报销类型
     */
    private String sourceType;

    /**
     * 报销类型（0：普通报销；1：电子发票报销）
     */
    private String reimbursementType;

    /**
     * 报销编号
     */
    private String no;

    /**
     * 付款时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date paymentTime;
    /**
     * 付款状态  0:未付款  1:已付款
     */
    private String paymentStatus;

    //发票号
    private String financeNumber;
}
