package com.jeeplus.finance.projectRecords.domain;

import com.baomidou.mybatisplus.annotation.TableName;
import com.jeeplus.core.domain.BaseEntity;
import com.jeeplus.core.query.Query;
import com.jeeplus.core.query.QueryType;
import lombok.Data;

import java.util.Date;

/**
 * @author: 徐滕
 * @version: 2022-11-10 14:55
 */
@Data
@TableName("cw_project_records")
public class CwProjectRecords extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 备注信息
     */
    private String remarks;

    /**
     * 项目编号
     */
    @Query(tableColumn = "a.project_number", type = QueryType.LIKE)
    private String projectNumber;

    /**
     * 项目名称
     */
    @Query(tableColumn = "a.project_name", type = QueryType.LIKE)
    private String projectName;

    /**
     * 项目所属部门
     */
    private String officeId;

    /**
     * 项目金额
     */
    private String projectMoney;

    /**
     * 审计期间
     */
    private String auditYear;

    /**
     * 项目计划开始时间
     */
    private Date planStartDate;

    /**
     * 项目计划结束时间
     */
    private Date planEndDate;

    /**
     * 项目经理
     */
    private String projectMasterId;

    /**
     * 现场负责人
     */
    private String projectLeaderId;

    /**
     * 流程id
     */
    private String procInsId;

    private String processDefinitionId;

    /**
     * 状态
     */
    @Query(tableColumn = "a.status", type = QueryType.EQ)
    private String status;

    /**
     * 合同id
     */
    private String contractId;

    /**
     * 业务类型
     */
    private String businessType;

    /**
     * 风险等级
     */
    private String riskLevel;

    /**
     * 项目实际责任人
     */
    private String realHeader;

    /**
     * 报备类型
     */
    private String reportType;

    /**
     * 报告复核 1：已开始复核/已完成复核
     */
    private String reportReview;

    /**
     * 项目分类（专项审计业务）
     */
    private String projectClassification;

    /**
     * 是否有报告(0:无,1:有)
     */
    private String isHaveReport;
    /**
     * 是否预开票(0:否,1:是)
     */
    private String isPreInvoice;




}
