package com.jeeplus.finance.projectReport.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.jeeplus.core.domain.BaseEntity;
import lombok.Data;

import java.util.Date;

/**
 * @author: 王强
 * @create: 2022-12-12 20:37
 **/
@Data
@TableName(value = "cw_project_report_review")
public class CwProjectReview extends BaseEntity {

    //报告编号基字（字典值）
    public static final String BIZ_CODE1 = "23";

    //报告编号咨字（字典值）
    public static final String BIZ_CODE2 = "24";

    //报告编号审字（字典值）
    public static final String BIZ_CODE3 = "25";

    //报告编号验字（字典值）
    public static final String BIZ_CODE4 = "26";

    //报告编号特字（字典值）
    public static final String BIZ_CODE5 = "27";

    /**
     * 流程id
     */
    private String procInsId;

    private String processDefinitionId;

    /**
     * 报告类型
     */
    @TableField(exist = false)
    private String reportType;

    /**
     * 状态
     */
    private String reviewStatus;

    /**
     * 本报告共印份数
     */
    private String allPrintNum;

    /**
     * 发出份数
     */
    private String issueNum;

    /**
     * 存档份数
     */
    private String placeOnFileNum;

    /**
     * 打印人签名
     */
    private String printedBy;

    /**
     * 校对人签名
     */
    private String checkAutograph;

    /**
     * 财务-报告表id
     */
    private String reportId;

    /**
     * 财务-报告编号
     */
    private String reportReviewNo;

    /**
     * 报告类型及标题
     */
    private String reportTitleType;

    /**
     * 一级复核需提请关注或修改的事项
     */
    private String needUpdate1;

    /**
     * 二级复核需提请关注或修改的事项
     */
    private String needUpdate2;

    /**
     * 三级复核需提请关注或修改的事项
     */
    private String needUpdate3;

    /**
     * 一级复核备注
     */
    private String remark1;

    /**
     * 二级复核备注
     */
    private String remark2;

    /**
     * 三级复核备注
     */
    private String remark3;

    /**
     * 计算机文号
     */
    private String computerNo;

    private String reviewBy;

    /**
     * 区分新旧数据
     */
    private String newType;

    /**
     * 审核通过时间
     */
    private Date auditTime;
}
