package com.jeeplus.finance.projectReport.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.jeeplus.finance.projectReport.domain.CwProjectReport;
import com.jeeplus.finance.projectReport.domain.CwSignatureAnnotator;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * 财务-修改签字注师记录表
 */
@Mapper
public interface CwSignatureAnnotatorMapper extends BaseMapper<CwSignatureAnnotator> {
    CwSignatureAnnotator getSigById(String id);

    /**
     * 根据报告id查询修改签字注师表中信息
     * @param reportIdList
     * @return
     */
    List<CwSignatureAnnotator> getSigByIdList(@Param("reportIdList") List<String> reportIdList);

    void updateStatusById(CwSignatureAnnotator cwSignatureAnnotator);

    void setClearReason(@Param("id")String id);

    void updateStatusBySigId(@Param("signatureAnnotatorStatus")String signatureAnnotatorStatus, @Param("id")String id);
}
