package com.jeeplus.human.depart.handover.controller;

import com.jeeplus.common.utils.ResponseUtil;
import com.jeeplus.human.depart.handover.domain.HandoverAccounts;
import com.jeeplus.human.depart.handover.domain.HandoverComputer;
import com.jeeplus.human.depart.handover.service.HandoverAccountsService;
import com.jeeplus.logging.annotation.ApiLog;
import com.jeeplus.logging.constant.enums.LogTypeEnum;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;

/**
 * @author 王强
 * @version 1.0
 * @date 2023-11-06 16:03
 */
@RestController
@Api("应收账款")
@RequestMapping(value = "/handoverAccounts")
public class HandoverAccountsController {

    @Resource
    private HandoverAccountsService accountsService;

    /**
     * 保存应收账款信息
     * @param accounts
     * @return
     */
    @ApiLog(value = "保存应收账款信息", type = LogTypeEnum.SAVE)
    @PostMapping("save")
    public ResponseEntity save(@Valid @RequestBody HandoverAccounts accounts) throws Exception {
        HandoverAccounts s = accountsService.saveComputer(accounts);
        return ResponseUtil.newInstance().add("businessTable", "human_resources_depart_handover_draft")
                .add("businessId", s.getId())
                .ok ("操作成功");
    }

    /**
     * 查询
     * @param id
     * @return
     */
    @ApiOperation(value = "查询")
    @GetMapping("/findById")
    public ResponseEntity<HandoverAccounts> findById(@RequestParam String id) throws Exception{
        HandoverAccounts dto = accountsService.findById(id);
        return ResponseEntity.ok(dto);
    }

    /**
     * 根据id修改状态status
     */
    @ApiOperation(value = "根据id修改状态status")
    @PostMapping(value = "updateStatusById")
    public void updateStatusById(@RequestBody HandoverAccounts dto) {
        accountsService.updateStatusById(dto);
    }
}
