package com.jeeplus.human.depart.handover.controller;

import com.jeeplus.common.utils.ResponseUtil;
import com.jeeplus.human.depart.handover.domain.Handover;
import com.jeeplus.human.depart.handover.domain.HandoverDraft;
import com.jeeplus.human.depart.handover.service.HandoverDraftService;
import com.jeeplus.logging.annotation.ApiLog;
import com.jeeplus.logging.constant.enums.LogTypeEnum;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;

/**
 * @author 王强
 * @version 1.0
 * @date 2023-11-02 9:49
 */
@RestController
@Api("底稿归档检查")
@RequestMapping(value = "/handoverDraft")
public class HandoverDraftController {

    @Resource
    private HandoverDraftService draftService;

    /**
     * 保存离职交接信息
     * @param draft
     * @return
     */
    @ApiLog(value = "保存底稿归档信息", type = LogTypeEnum.SAVE)
    @PostMapping("save")
    public ResponseEntity save(@Valid @RequestBody HandoverDraft draft) throws Exception {
        HandoverDraft s = draftService.saveDraft(draft);
        return ResponseUtil.newInstance().add("businessTable", "human_resources_depart_handover_draft")
                .add("businessId", s.getId())
                .ok ("操作成功");
    }

    /**
     * 查询
     * @param id
     * @return
     */
    @ApiOperation(value = "查询")
    @GetMapping("/findById")
    public ResponseEntity<HandoverDraft> findById(@RequestParam String id) throws Exception{
        HandoverDraft dto = draftService.findById(id);
        return ResponseEntity.ok(dto);
    }

    /**
     * 根据id修改状态status
     */
    @ApiOperation(value = "根据id修改状态status")
    @PostMapping(value = "updateStatusById")
    public void updateStatusById(@RequestBody HandoverDraft dto) {
        draftService.updateStatusById(dto);
    }
}
