package com.jeeplus.human.depart.handover.controller;

import com.jeeplus.common.utils.ResponseUtil;
import com.jeeplus.human.depart.handover.domain.HandoverImprest;
import com.jeeplus.human.depart.handover.service.HandoverImprestService;
import com.jeeplus.logging.annotation.ApiLog;
import com.jeeplus.logging.constant.enums.LogTypeEnum;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;

/**
 * @author 王强
 * @version 1.0
 * @date 2023-11-14 9:11
 */
@RestController
@Api("备用金")
@RequestMapping(value = "/handoverImprest")
public class HandoverImprestController {

    @Resource
    private HandoverImprestService imprestService;

    /**
     * 保存应收账款信息
     * @param imprest
     * @return
     */
    @ApiLog(value = "保存社保账款信息", type = LogTypeEnum.SAVE)
    @PostMapping("save")
    public ResponseEntity save(@Valid @RequestBody HandoverImprest imprest) throws Exception {
        HandoverImprest s = imprestService.saveImprest(imprest);
        return ResponseUtil.newInstance().add("businessTable", "human_resources_depart_handover_imprest")
                .add("businessId", s.getId())
                .ok ("操作成功");
    }

    /**
     * 查询
     * @param id
     * @return
     */
    @ApiOperation(value = "查询")
    @GetMapping("/findById")
    public ResponseEntity<HandoverImprest> findById(@RequestParam String id) throws Exception{
        HandoverImprest dto = imprestService.findById(id);
        return ResponseEntity.ok(dto);
    }

    /**
     * 根据id修改状态status
     */
    @ApiOperation(value = "根据id修改状态status")
    @PostMapping(value = "updateStatusById")
    public void updateStatusById(@RequestBody HandoverImprest dto) {
        imprestService.updateStatusById(dto);
    }
}
