package com.jeeplus.human.depart.handover.controller;

import com.jeeplus.common.utils.ResponseUtil;
import com.jeeplus.human.depart.handover.domain.HandoverAccounts;
import com.jeeplus.human.depart.handover.domain.HandoverSocialSecurity;
import com.jeeplus.human.depart.handover.service.HandoverSocialSecurityService;
import com.jeeplus.logging.annotation.ApiLog;
import com.jeeplus.logging.constant.enums.LogTypeEnum;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;

/**
 * @author 王强
 * @version 1.0
 * @date 2023-11-07 9:34
 */
@RestController
@Api("社保账款")
@RequestMapping(value = "/handoverSocialSecurity")
public class HandoverSocialSecurityController {

    @Resource
    private HandoverSocialSecurityService securityService;

    /**
     * 保存应收账款信息
     * @param socialSecurity
     * @return
     */
    @ApiLog(value = "保存社保账款信息", type = LogTypeEnum.SAVE)
    @PostMapping("save")
    public ResponseEntity save(@Valid @RequestBody HandoverSocialSecurity socialSecurity) throws Exception {
        HandoverSocialSecurity s = securityService.saveSocialSecurity(socialSecurity);
        return ResponseUtil.newInstance().add("businessTable", "human_resources_depart_handover_social_security")
                .add("businessId", s.getId())
                .ok ("操作成功");
    }

    /**
     * 查询
     * @param id
     * @return
     */
    @ApiOperation(value = "查询")
    @GetMapping("/findById")
    public ResponseEntity<HandoverSocialSecurity> findById(@RequestParam String id) throws Exception{
        HandoverSocialSecurity dto = securityService.findById(id);
        return ResponseEntity.ok(dto);
    }

    /**
     * 根据id修改状态status
     */
    @ApiOperation(value = "根据id修改状态status")
    @PostMapping(value = "updateStatusById")
    public void updateStatusById(@RequestBody HandoverSocialSecurity dto) {
        securityService.updateStatusById(dto);
    }
}
