package com.jeeplus.human.depart.registration.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.jeeplus.core.domain.BaseEntity;
import lombok.Data;

import java.util.List;

/**
 * 离职申请
 * @author 王强
 * @version 1.0
 * @date 2023-10-25 9:41
 */
@Data
@TableName("human_resources_depart_registration")
public class DepartRegistration extends BaseEntity {

    private String name;
    private String projectManager;
    private String remarks;                 //备注
    private String department;              //所属部门
    private String arrivalDate;             //到岗日期
    private String departResignationDate;   //预定离职日期
    private String type;                //流程状态
    private String procInsId;
    private String processDefinitionId;

    @TableField(exist = false)
    private String dimissionProveUrl; //离职证明路径

    @TableField(exist = false)
    private String taskId;

    @TableField(exist = false)
    private List<String> auditUserIds;

    @TableField(exist = false)
    private String departmentName;

    @TableField(exist = false)
    private String handoverProcInsId;   //离职交接表的

    @TableField(exist = false)
    private String handoverId;  //离职交接表id

    @TableField(exist = false)
    private String handoverType;  //离职交接表状态
    @TableField(exist = false)
    private String handoverTaskId;  //离职交接表流程id

    @TableField(exist = false)
    private String mobile;

    //备用金检查表
    @TableField(exist = false)
    private String imprestId;
    @TableField(exist = false)
    private String imprestProcInsId;
    @TableField(exist = false)
    private String imprestProcDefId;
    @TableField(exist = false)
    private String imprestType;

    //电脑款项检查表
    @TableField(exist = false)
    private String computerId;
    @TableField(exist = false)
    private String computerProcInsId;
    @TableField(exist = false)
    private String computerProcDefId;
    @TableField(exist = false)
    private String computerType;

    //应收账款检查表
    @TableField(exist = false)
    private String accountsId;
    @TableField(exist = false)
    private String accountsProcInsId;
    @TableField(exist = false)
    private String accountsProcDefId;
    @TableField(exist = false)
    private String accountsType;

    //社保账款检查表
    @TableField(exist = false)
    private String securityId;
    @TableField(exist = false)
    private String securityProcInsId;
    @TableField(exist = false)
    private String securityProcDefId;
    @TableField(exist = false)
    private String securityType;

    //底稿归档检查表
    @TableField(exist = false)
    private String draftId;
    @TableField(exist = false)
    private String draftProcInsId;
    @TableField(exist = false)
    private String draftProcDefId;
    @TableField(exist = false)
    private String draftType;

    //门卡回收表
    @TableField(exist = false)
    private String recoveryId;
    @TableField(exist = false)
    private String recoveryProcInsId;
    @TableField(exist = false)
    private String recoveryProcDefId;
    @TableField(exist = false)
    private String recoveryType;
}
