package com.jeeplus.human.practice.logwrite.service.dto;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.jeeplus.core.domain.BaseEntity;
import com.jeeplus.core.service.dto.BaseDTO;
import com.jeeplus.human.practice.logwrite.domain.RegistrationWorkLogDetail;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;

/**
 * 实习日志
 * @author 王强
 * @version 1.0
 * @date 2023-09-15 9:38
 */
@Data
@TableName("human_resources_practice_registration_work_log")
public class RegistrationWorkLogDto extends BaseEntity {

    /**
     * 数据审核人  入库 修改申请
     */
    private List<String> auditUserIds;

    private String createName;

    private String type;

    private String taskId;

    /**
     * 流程id
     */
    private String procInsId;

    /**
     *
     */
    private String processDefinitionId;

    //开始时间
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private String startTime;
    //结束时间
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private String endTime;
    //实习天数
    private String internshipDays;
    //实习地点
    private String internshipLocation;
    //跟踪项目名称
    private String trackingProjectName;
    //工作内容
    private String work;
    //备注
    private String remarks;
    //项目经理
    private String projectManager;

    //实习工作日志名称
    private String workName;

    private String projectManagerName;

    private List<RegistrationWorkLogDetail> amountInfos;

    @TableField(exist = false)
    private String[] createDates;

    //报销登记的金额汇总
    private String allMoney;
}
