package com.jeeplus.human.practice.register.mapper;

import com.baomidou.mybatisplus.annotation.InterceptorIgnore;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.jeeplus.human.practice.register.domain.RegistrationFamilyMembers;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author 王强
 * @version 1.0
 * @date 2023-09-22 9:04
 */
@Mapper
@InterceptorIgnore(tenantLine = "true")
public interface FamilyMembersMapper extends BaseMapper<RegistrationFamilyMembers> {

    /**
     * 根据实习人员登记表id删除家庭成员信息
     * @param registerId
     */
    void deleteByRegisterId(@Param("registerId") String registerId);

    /**
     * 根据实习人员登记表id查询家庭成员信息
     * @param registerId
     * @return
     */
    List<RegistrationFamilyMembers> getByRegisterId(@Param("registerId") String registerId);
}
