package com.jeeplus.human.practice.reimburseRegister.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.jeeplus.core.domain.BaseEntity;
import com.jeeplus.sys.domain.WorkAttachmentInfo;
import lombok.Data;

import java.util.List;

/**
 * 实习-报销
 * @author 王强
 * @version 1.0
 * @date 2023-09-22 13:48
 */
@Data
@TableName("human_resources_practice_reimburse_submit_account")
public class ReimburseSubmitAccount extends BaseEntity {

    public static final String BIZ_CODE = "31";

    private String remarks;  //备注

    private String procInsId;

    private String processDefinitionId;

    private String type;

    private String operator;        //经办人
    private String operatorOffice;  //经办人部门
    @JsonFormat(pattern = "yyyy-MM-dd")
    private String reimDate;        //报销日期
    private String no;              //报销编号
    private String totalNum;          //报销金额
    @TableField(exist = false)
    private String taskId;

    @TableField(exist = false)
    private List<WorkAttachmentInfo> files;

    /**
     * 数据审核人  入库 修改申请
     */
    @TableField(exist = false)
    private List<String> auditUserIds;

    @TableField(exist = false)
    private List<ReimburseSubmitAccountDetail> accountDetails;
}
