package com.jeeplus.pubmodules.knowledge.service.dto;

import com.fasterxml.jackson.annotation.JsonFormat;

import com.jeeplus.pubmodules.editor.service.dto.EditorFilesDTO;
import com.jeeplus.pubmodules.knowledge.domain.KnowledgeShareComment;
import com.jeeplus.pubmodules.knowledge.domain.KnowledgeShareVisit;
import com.jeeplus.sys.service.dto.WorkAttachmentInfoDTO;
import lombok.Data;

import java.util.Date;
import java.util.List;

@Data
public class KnowledgeShareInfoDto {

    /**
     * 主键
     */
    private String id;

    /**
     * 创建人
     */
    private String createBy;

    /**
     * 创建时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date createDate;

    /**
     * 更新人
     */
    private String updateBy;

    /**
     * 更新时间
     */
    private Date updateDate;

    /**
     * 删除状态
     */
    private Integer delFlag;

    /**
     * 知识分享类型id
     */
    private String typeId;

    /**
     * 知识分享类型名称
     */
    private String typeName;

    /**
     * 主题
     */
    private String title;

    /**
     * 内容
     */
    private String detail;

    /**
     * 访问记录
     */
    private List<KnowledgeShareVisit> visits;

    /**
     * 评论记录
     */
    private List<KnowledgeShareComment> comments;

    /**
     * 附件列表
     */
    private List<WorkAttachmentInfoDTO> files;

    /**
     * 富文本图片集合
     */
    private List<EditorFilesDTO> editorFilesDTOList;

    /**
     * 阅读量
     */
    private Integer visitNum;

}
