package com.jeeplus.pubmodules.meetingRoom.service.dto;

import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.jeeplus.core.service.dto.BaseDTO;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.sql.Time;
import java.util.Date;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class MeetingRoomDTO extends BaseDTO {

    private String id;

    /**
     * 标题
     */
    private String title;

    /**
     * 会议开始,结束时间
     */

    private Time startTime;

    private Time endTime;
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private String startDate;

    /**
     * 会议时长
     */
    private Integer duration;

    /**
     * 会议说明
     */
    private String remarks;

    /**
     * 流程id
     */
    private String procInsId;

    /**
     * 流程信息
     */
    private String processDefinitionId;
    private String taskId;

    /**
     * 状态
     */
    private String status;

    /**
     * 会议室编号
     */
    private String meetNumber;

    /**
     * 创建时间
     */
    @TableField(exist = false)
    private String[] meetingDates;

    /**
     * 创建人
     */
    @TableField(exist = false)
    private String createName;
    @TableField(exist = false)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createDate;

    /**
     * 部门
     */
    @TableField(exist = false)
    private String officeId;
    @TableField(exist = false)
    private String officeName;

    private String createById;

    private static final long serialVersionUID = 1L;









}
