package com.jeeplus.pubmodules.purchase.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.jeeplus.core.domain.BaseEntity;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * 物资管理-采购基础表
 * @author: 王强
 * @create: 2022-12-02 16:40
 **/
@Data
@TableName("material_management_pruchase_request_basics")
public class MaterialBasic extends BaseEntity {

    //采购编号（字典值）
    public static final String BIZ_CODE = "16";

    /**
     * 流程id
     */
    private String procInsId;

    /**
     * 状态
     */
    private String status;

    private String processDefinitionId;

    /**
     * 采购编号
     */
    private String purchaseNo;

    /**
     * 采购简述
     */
    private String purchaseSketch;

    /**
     * 经办人
     */
    private String handledBy;

    /**
     * 经办人部门
     */
    private String handledByOffice;

    /**
     * 经办人部门
     */
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date purchaseDate;

    /**
     * 采购方式
     */
    private String purchaseMode;

    /**
     * 备注
     */
    private String remarks;

    @TableField(exist = false)
    List<MaterialDetailed> detailInfos;
}
