package com.jeeplus.pubmodules.workCollectAccessory.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.jeeplus.core.domain.BaseEntity;
import com.jeeplus.sys.domain.WorkAttachmentInfo;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;


@Data
@NoArgsConstructor
@AllArgsConstructor
@TableName("work_collect_accessory")
public class WorkCollectAccessory extends BaseEntity {
    /** 主键 */
    private String id;


    /** 备注信息 */
    private String remarks;

    /** 文件地址 */
    private String url;

    /** 文件名称 */
    private String fileName;

    /** 收藏类型（1：个人上传；2：部门共享；3：公司共享） */
    private String type;

    /** 部门id */
    private String officeId;

    /** 公司id */
    private String companyId;

    /** 是否收藏（1：收藏；0：未收藏） */
    private String collectType;

    /** 上传人 */
    private String collectUserId;

    /** 文件大小 */
    private String fileSize;

    /** 收藏分类 */
    private String classification;

    /** 文件描述 */
    private String fileDescription;

    /** 是否部门共享（0：否；1：是） */
    private String officeShare;

    /** 是否公司共享（0：否；1：是） */
    private String companyShare;

    @TableField(exist = false)
    private String userName;

    @TableField(exist = false)
    private String collectUserName;

    @TableField(exist = false)
    private List<WorkAttachmentInfo> workAttachments;
}
