package com.jeeplus.pubmodules.workCollectAccessory.mapper;

import com.baomidou.mybatisplus.annotation.InterceptorIgnore;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jeeplus.pubmodules.meetingRoom.domain.MeetingRoom;
import com.jeeplus.pubmodules.oss.domain.WorkAttachment;
import com.jeeplus.pubmodules.workCollectAccessory.domain.WorkCollectAccessory;
import com.jeeplus.pubmodules.workCollectAccessory.service.dto.DictValueDTO;
import com.jeeplus.sys.domain.DictType;
import com.jeeplus.sys.domain.DictValue;
import com.jeeplus.sys.domain.WorkAttachmentInfo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import java.util.Date;
import java.util.List;

@Mapper
public interface WorkCollectAccessoryMapper extends BaseMapper<WorkCollectAccessory> {
    @InterceptorIgnore(tenantLine = "true")
    IPage<WorkCollectAccessory> findPageList(Page<WorkCollectAccessory> page, @Param(Constants.WRAPPER) QueryWrapper<WorkCollectAccessory> workCollectAccessoryMapperQueryWrapper);


    DictType getDictByName(@Param("dictName")String dictName);

    void insertDictValue(DictValueDTO dictValue);

    void deleteAttachment(@Param("id")String id);

    List<WorkAttachmentInfo> listWorkAttachment(@Param("attachmentId")String id);

    List<DictValue> getDictValueByName(@Param("dictName") String dictName);

}
