package com.jeeplus.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.jeeplus.core.service.dto.BaseDTO;

import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;


@Data
public class CwProjectRecordsList  {

    /**
     * 项目id
     */
    private String id;

    /**
     * 创建人id
     */
    private String createById;

    /**
     * 备注信息
     */
    private String remarks;

    /**
     * 项目编号
     */
    private String projectNumber;

    /**
     * 项目名称
     */
    private String projectName;

    /**
     * 项目所属部门
     */
    private String officeId;

    /**
     * 项目金额
     */
    private String projectMoney;

    /**
     * 审计期间
     */
    private String auditYear;

    /**
     * 项目计划开始时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date planStartDate;

    /**
     * 项目计划结束时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date planEndDate;

    /**
     * 项目经理
     */
    private String projectMasterId;

    /**
     * 现场负责人
     */
    private String projectLeaderId;

    /**
     * 流程id
     */
    private String procInsId;

    /**
     *
     */
    private String processDefinitionId;

    /**
     * 状态
     */
    private String status;






    /**
     * 项目经理姓名
     */
    private String projectMasterName;

    private String projectMasterName2;
    /**
     * 时间查询
     */
    private String[] createDates;

    /**
     * 合同id
     */
    private String contractId;

    /**
     * 付款方式
     */
    private String paymentMethod;

    /**
     * 付款主体
     */
    private String payerSubject;

    /**
     * 合同份数
     */
    private String contractNum;

    /**
     * 合同金额(元)
     */
    private String contractAmount;

    /**
     * 合同名称
     */
    private String contractName;

    /**
     * 创建人id
     */
    private String createId;

    /**
     * 创建人姓名
     */
    private String createName;

    /**
     * 创建时间
     */
    private String createDateT;

    /**
     * 业务类型
     */
    private String businessType;

    /**
     * 风险等级
     */
    private String riskLevel;

    /**
     * 业务类型名称
     */
    private String businessTypeName;

    /**
     * 项目预计时间
     */
    private Date[] planDate;

    /**
     * 项目实际责任人
     */
    private String realHeader;

    /**
     * 项目实际责任人
     */
    private String realHeaderName;

    /**
     * 合同委托人
     */
    private String clientContactsName;

    /**
     * 报备类型
     */
    private String reportType;

    /**
     * 项目分类（专项审计业务）
     */
    private String projectClassification;



    /**
     * 项目组成员数量
     */
    private String memberCount;

    /**
     * 报告复核 1：已开始复核/已完成复核
     */
    private String reportReview;

    /**
     * 查找该报告及报告对应项目下的开票列表
     */
    private String reportNo;
    private String no;
    private String number;
    private String account;
    private String billingPeople;
    private String billingDate;

    /**
     * 该项目下审计收费不为0的报告信息
     */
    private String auditFees;
    private String loginName;
    private String reportId;

    /**
     * 是否有报告(0:无,1:有)
     */
    private String isHaveReport;
    /**
     * 是否预开票(0:否,1:是)
     */
    private String isPreInvoice;

    /**
     * 项目下的开票信息数量
     */
    private Integer invoiceTotal;



}
