package com.jeeplus.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.jeeplus.core.domain.BaseEntity;
import lombok.Data;

/**
 * 入职人员登记
 * @author 王强
 * @version 1.0
 * @date 2023-09-27 14:14
 */
@Data
@TableName("human_resources_enrollment_registration")
public class EnrollmentRegistrationInfo extends BaseEntity {
    private String name;                //姓名
    private String sex;                 //性别
    private String age;                 //年龄
    private String birthday;            //出生日期
    private String politicalOutlook;    //政治面貌
    private String nativePlace;         //籍贯
    private String nation;              //民族
    private String maritalStatus;       //婚姻状况
    private String mobilePhone;         //联系电话
    private String idCard;              //身份证号码
    private String homeAddress;         //家庭住址
    private String permanentAddress;    //常住地址
    private String graduatedFrom;       //毕业院校
    private String speciality;          //专业
    private String startTime;           //开始时间
    private String endTime;             //毕业时间
    private String education;           //学历
    private String educationNature;     //学历性质
    private String graduatedOrNot;      //是否毕业
    private String englishLevel;        //英语等级
    private String ncre;                //计算机等级
    private String department;          //所属部门
    private String entryDate;           //进所日期
    private String contractStartDate;   //合同开始日期
    private String remarks;             //备注
    private String type;                //流程状态
    private String procInsId;
    private String processDefinitionId;
    private String userId;              //用户id
    private String projectManager;      //项目经理

    @TableField(exist = false)
    private String socialSecurityNumber;        //社保编号
    @TableField(exist = false)
    private String socialSecurityBankNumber;    //社保银行卡号
    @TableField(exist = false)
    private String socialSecurityPictureFront;       //社保卡照片正面
    @TableField(exist = false)
    private String socialSecurityPictureFrontUrl;       //社保卡照片正面URL
    @TableField(exist = false)
    private String socialSecurityPictureOpposite;       //社保卡照片反面
    @TableField(exist = false)
    private String socialSecurityPictureOppositeUrl;       //社保卡照片反面URL
    private String onJobStatus;       //在职状态

}
