package com.jeeplus.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.jeeplus.core.domain.BaseEntity;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

/**
 * 实习人员登记表
 * @author 王强
 * @version 1.0
 * @date 2023-09-13 11:00
 */
@Data
public class RegistrationInfo extends BaseEntity {
    private String name;                //姓名
    private String sex;                 //性别
    private String idCard;              //身份证号码
    private String nativePlace;         //出生地
    private String nation;              //民族
    private String politicalOutlook;    //政治面貌
    private String graduatedFrom;       //毕业院校
    private String speciality;          //专业
    private String mobilePhone;         //联系电话
    private String qqNum;               //QQ
    private String type;                //流程状态
    private String procInsId;
    private String processDefinitionId;
    private String practiceStatus;      //实习状态
    private String userId;              //用户id
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private String practiceCompleteDay; //实习结束时间
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private String practiceStartDay;    //实习开始时间
    private String practiceOffice;    //实习部门
    private String practiceUnitName;    //实习单位名称
    private String projectManager;      //项目经理
    private String remarks;      //备注

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private String lastWorkLogDay;  //最后一次实习日志填写时间
    //日志名称
    private String workName;
}
